package cz.cvut.kbss.reporting.service.repository;

import cz.cvut.kbss.reporting.environment.Environment;
import cz.cvut.kbss.reporting.environment.Generator;
import cz.cvut.kbss.reporting.model.OccurrenceReport;
import cz.cvut.kbss.reporting.model.Person;
import cz.cvut.kbss.reporting.model.Tag;
import cz.cvut.kbss.reporting.service.BaseServiceTestRunner;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotEquals;
import static org.junit.Assert.assertNotNull;
import org.junit.Before;
import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;

public class TagServiceTest extends BaseServiceTestRunner {

    @Autowired
    private TagService tagService;

    private Person author;

    @Before
    public void setUp() {
        this.author = Generator.generatePerson();
        persistPerson(author);
        Environment.setCurrentUser(author);
    }

    @Test
    public void persistSetsAuthorToCurrentlyLoggedInUserAndCreatedToCurrentTime() {
        final Tag tag = Generator.generateTag("sample-tag");
        tag.setAuthor(null);
        tag.setCreated(null);
        tagService.persist(tag);

        assertEquals(tagService.findAll().size(), 1);
        Tag persistedTag = tagService.findAll().get(0);
        assertEquals(author, persistedTag.getAuthor());
        assertNotNull(persistedTag.getCreated());
    }

}